#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <tchar.h>
#include <commctrl.h>
#include <shellapi.h>
#include "resource.h"

HBRUSH g_hbPozadi;
HINSTANCE g_hInst;
LOGFONT logFont;
HFONT hfNadpis;

/////////////////////////////////////////////////////////////////////////////
// Pi sputn nastavme tlatku bitmapu

void On_InitDialog(HWND hWnd)
{
	SendDlgItemMessage(hWnd, IDC_HONZA, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP,
		(LPARAM)LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_HONZA)));
}

/////////////////////////////////////////////////////////////////////////////
// Uivatelsk kreslen tlatek

void On_DrawItem(LPDRAWITEMSTRUCT lpDIS)
{
	HBRUSH hbPozadi = CreatePatternBrush(LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_POZADI)));
	if ( lpDIS->itemState & ODS_SELECTED )
		DrawFrameControl(lpDIS->hDC, &lpDIS->rcItem, DFC_BUTTON, DFCS_BUTTONPUSH | DFCS_PUSHED);
	else
		DrawFrameControl(lpDIS->hDC, &lpDIS->rcItem, DFC_BUTTON, DFCS_BUTTONPUSH);
	InflateRect(&lpDIS->rcItem, -4,-4);
	FillRect(lpDIS->hDC, &lpDIS->rcItem, hbPozadi);
	SetBkMode(lpDIS->hDC, TRANSPARENT);
	SetTextColor(lpDIS->hDC, 0x00A0FFFF);
	switch ( lpDIS->CtlID )
	{
		case IDC_INFO:
			DrawIcon(lpDIS->hDC,
				(lpDIS->rcItem.right - lpDIS->rcItem.left + 8
					- GetSystemMetrics(SM_CXICON))/2,
				lpDIS->rcItem.top + 5,
				LoadIcon(NULL, IDI_INFORMATION));
				lpDIS->rcItem.top = lpDIS->rcItem.bottom - 20;
			DrawText(lpDIS->hDC, TEXT("O progamu"), -1, &lpDIS->rcItem,
				DT_SINGLELINE | DT_CENTER | DT_VCENTER);
			break;
		case IDC_CHYBA:
			DrawIcon(lpDIS->hDC,
				(lpDIS->rcItem.right - lpDIS->rcItem.left + 8
					- GetSystemMetrics(SM_CXICON))/2,
				lpDIS->rcItem.top + 5,
				LoadIcon(NULL, IDI_ERROR));
				lpDIS->rcItem.top = lpDIS->rcItem.bottom - 20;
			DrawText(lpDIS->hDC, TEXT("Bug report"), -1, &lpDIS->rcItem,
				DT_SINGLELINE | DT_CENTER | DT_VCENTER);
			break;
	}
	DeleteObject(hbPozadi);
}

/////////////////////////////////////////////////////////////////////////////
// procedura dialogu

INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
				case IDCANCEL:
					DeleteObject(g_hbPozadi);
					EndDialog(hwndDlg, LOWORD(wParam));
					break;
				case IDC_HONZA:
					ShellExecute(NULL, TEXT("open"),
						TEXT("http://www.rplusj.cz/index.asp?stranka=fotogalerie.htm"),
						NULL, NULL, SW_SHOWMAXIMIZED);
					break;
				case IDC_CHYBA:
					ShellExecute(NULL, TEXT("open"),
						TEXT("http://www.rplusj.cz/obrazek.asp?src=data/foto/sranda/kdyz_usa_prohraje.jpg"),
						NULL, NULL, SW_SHOWMAXIMIZED);
					break;
				case IDC_INFO:
					ShellExecute(NULL, TEXT("open"),
						TEXT("http://www.rcsoft.cz"),
						NULL, NULL, SW_SHOWMAXIMIZED);
					break;
			}
			break;
		case WM_DRAWITEM:
			On_DrawItem((LPDRAWITEMSTRUCT)lParam);
			break;
		case WM_INITDIALOG:
			On_InitDialog(hwndDlg);
			break;
	}	
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Hlavn funkce programu ve Windows

int WINAPI _tWinMain(HINSTANCE hInstance,	HINSTANCE hPrevInstance,
	LPTSTR lpCmdLine, int nCmdShow)
{
	g_hInst = hInstance;
	InitCommonControls();
	return (int)DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG_HLAVNI), NULL,
		(DLGPROC)DialogProc);
}